﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CPF_experement
{
    /// <summary>
    /// This class represents a state in the A* search with operator decomposition, as proposed by Trevor Scott Standley's AAAI paper in 2010.
    /// More specifically, states can represent a partial move, in which only some of the agents has moved
    /// and the other have not yet moved in this turn. 
    /// </summary>
    class FocalNodeAStar : IComparable<IBinaryHeapItem> , IBinaryHeapItem
    {
        private int binaryHeapIndex;
        public WorldState orgnl;
        public int g;
        public int h;
        public int dncInternalConflictsCount;


        public FocalNodeAStar(WorldState cpy)
        {
            this.g = cpy.g;
            this.h = cpy.h;
            this.dncInternalConflictsCount = cpy.dncInternalConflictsCount;
            orgnl = cpy;
        }

        /// <summary>
        /// BH_Iteam implimatation
        /// </summary>
        /// <returns></returns>
        public int getIndexInHeap() { return binaryHeapIndex; }
        /// <summary>
        /// BH_Iteam implimatation
        /// </summary>
        /// <returns></returns>
        public void setIndexInHeap(int index) { binaryHeapIndex = index; }

        public int CompareTo(IBinaryHeapItem other)
        {
            FocalNodeAStar that = (FocalNodeAStar)other;

            if (this.dncInternalConflictsCount < that.dncInternalConflictsCount)
                return -1;
            if (this.dncInternalConflictsCount > that.dncInternalConflictsCount)
                return 1;

            //if (this.dncInternalConflictsCount * this.h < that.dncInternalConflictsCount * that.h)
            //    return -1;
            //if (this.dncInternalConflictsCount * this.h > that.dncInternalConflictsCount * that.h)
            //    return 1;

            if (this.h + this.g < that.h + that.g)
                return -1;
            if (this.h + this.g > that.h + that.g)
                return 1;

            if (this.g < that.g)
                return 1;
            if (this.g > that.g)
                return -1;

            return 0;
        }

    }
}
