﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CPF_experement
{
    /// <summary>
    /// Describes a node in the A* search space.
    /// </summary>
    class FocalNodeCBS : IComparable<IBinaryHeapItem> , IBinaryHeapItem
    {
        /// <summary>
        /// Dummy node stores in focal List for CBS
        /// </summary>
        
        private int binaryHeapIndex;
        public int ver = 2; // 0 - CBS 1 - TC + conflict TB 2 - Conflict 3 - replan 4 -  couple 5 - replan-couple-conflict
        public int couple = 0;
        public int replanNum = 0;
        public int vCover = 0;
        public int depth = 0;
        public double costExp = 0;
        public ushort internalConflictsCount;
        public int totalCost;

        public DnCNode orgnl;

        /// <summary>
        /// Create a state with the given state for every agent.
        /// </summary>
        /// <param name="allAgentsState"></param>
        public FocalNodeCBS(DnCNode cpy)
        {
            orgnl = cpy;
            couple = cpy.couple;
            replanNum = cpy.replanNum;
            vCover = cpy.vCover;
            depth = cpy.depth;
            costExp = cpy.costExp;
            internalConflictsCount = cpy.internalConflictsCount;
            totalCost = cpy.totalCost;
        }

        /// <summary>
        /// BH_Iteam implimatation
        /// </summary>
        /// <returns></returns>
        public int getIndexInHeap() { return binaryHeapIndex; }
        /// <summary>
        /// BH_Iteam implimatation
        /// </summary>
        /// <returns></returns>
        public void setIndexInHeap(int index) { binaryHeapIndex = index; }

        public int CompareTo(IBinaryHeapItem item)
        {
            FocalNodeCBS other = (FocalNodeCBS)item;

            if (Constants.H_VER == 0)
            {
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else if (Constants.H_VER == 1)
            {
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.internalConflictsCount < other.internalConflictsCount)
                    return -1;
                if (this.internalConflictsCount > other.internalConflictsCount)
                    return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else if (Constants.H_VER == 2)
            {
                if (this.internalConflictsCount < other.internalConflictsCount)
                    return -1;
                if (this.internalConflictsCount > other.internalConflictsCount)
                    return 1;
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else if (Constants.H_VER == 3)
            {
                if (this.couple < other.couple)
                    return -1;
                if (this.couple > other.couple)
                    return 1;
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else if (Constants.H_VER == 4)
            {
                if (this.replanNum < other.replanNum)
                    return -1;
                if (this.replanNum > other.replanNum)
                    return 1;
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else if (Constants.H_VER == 5)
            {
                if (this.vCover < other.vCover)
                    return -1;
                if (this.vCover > other.vCover)
                    return 1;
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else if (Constants.H_VER == 6)
            {
                if (this.costExp < other.costExp)
                    return -1;
                if (this.costExp > other.costExp)
                    return 1;
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else if (Constants.H_VER == 7)
            {
                if (this.totalCost + this.costExp < other.totalCost + other.costExp)
                    return -1;
                if (this.totalCost + this.costExp > other.totalCost + other.costExp)
                    return 1;
                if (this.costExp < other.costExp)
                    return -1;
                if (this.costExp > other.costExp)
                    return 1;
                //if (this.totalCost < other.totalCost)
                //    return -1;
                //if (this.totalCost > other.totalCost)
                    //return 1;
                if (this.depth > other.depth)
                    return -1;
                if (this.depth < other.depth)
                    return 1;
                return 0;
            }
            else
            {
                if (this.couple < other.couple)
                    return -1;
                if (this.couple > other.couple)
                    return 1;
                if (this.totalCost < other.totalCost)
                    return -1;
                if (this.totalCost > other.totalCost)
                    return 1;
                if (this.depth < other.depth)
                    return -1;
                if (this.depth > other.depth)
                    return 1;
                return 0;
            }
        }


    }

}
